<template>
  <div id="app">
    <v-app>
      <!--<img src="./assets/logo.png">-->
      <v-navigation-drawer fixed light clipped app v-model="drawer">
        <v-list dense>
          <template v-for="(item, i) in items">
            <v-layout
              row
              v-if="item.heading"
              align-center
              :key="i"
            >
              <v-flex xs6>
                <v-subheader v-if="item.heading">{{ item.heading }}</v-subheader>
              </v-flex>
            </v-layout><!--/Heading-->
            <v-list-group v-else-if="item.children" v-model="item.model" v-bind:key="item.id" no-action>
              <v-list-tile
                exact ripple
                slot="item"
                @click="''"
              >
                <v-list-tile-action>
                  <v-icon>{{ item.model ? item.icon : item['icon-alt'] }}</v-icon>
                </v-list-tile-action>
                <v-list-tile-content>
                  <v-list-tile-title>{{ item.text }}</v-list-tile-title>
                </v-list-tile-content>
              </v-list-tile><!--/List Group Parent-->
              <v-list-tile
                exact ripple
                v-for="(child, i) in item.children"
                :key="i"
                @click="itemClickEvent(child.path)"
              >
                <v-list-tile-action v-if="child.icon">
                  <v-icon>{{ child.icon }}</v-icon>
                </v-list-tile-action>
                <v-list-tile-content>
                  <v-list-tile-title>{{ child.text }}</v-list-tile-title>
                </v-list-tile-content>
              </v-list-tile><!--/Children List-->
            </v-list-group>
            <v-list-tile
              exact ripple
              v-else
              v-bind:key="item.id"
              @click="itemClickEvent(item.path)"
            >
              <v-list-tile-action>
                <v-icon>{{ item.icon }}</v-icon>
              </v-list-tile-action>
              <v-list-tile-content>
                <v-list-tile-title>{{ item.text }}</v-list-tile-title>
              </v-list-tile-content>
            </v-list-tile>
          </template>
        </v-list>
      </v-navigation-drawer>

      <v-toolbar clipped-left fixed dark app color="light-green">
        <v-toolbar-title class="white--text mr-9 pl-8">
          <v-toolbar-side-icon @click.stop="drawer = !drawer"></v-toolbar-side-icon>
          <span class="hidden-xs-only">{{ title }}</span>
        </v-toolbar-title>
        <v-spacer></v-spacer>
        <v-btn icon @click="refresh">
          <v-icon>refresh</v-icon>
        </v-btn>
        <v-btn icon>
          <v-icon>more_vert</v-icon>
        </v-btn>
      </v-toolbar>

      <v-content>
        <router-view/>
      </v-content>

      <logger></logger>
    </v-app>
  </div>
</template>

<script>
/* eslint-disable */
import { mapState, mapActions } from 'vuex'
import Logger from './components/Logger'

export default {
  name: 'App',
  components: {
    Logger
  },
  data: () => {
    return {
      title: 'Sistem Informasi Akademik L',    
      drawer: null,
      items: [
        { icon: 'home', path: '/', text: 'Home' },
        { icon: 'info', path: '', text: 'Informasi' },
        { icon: 'schedule', path: '', text: 'Jadwal' },
        { icon: 'child_friendly', path: '', text: 'Teman Kelas' },            
        {
          icon: 'chat_bubble',
          'icon-alt': 'chat_bubble',
          path: '',
          text: 'Percakapan',
          model: false,
          children: [
            { icon: 'add', path: '', text: 'Create label' },
            { icon: 'add', path: '', text: 'Create label' },
            { icon: 'add', path: '', text: 'Create label' },
            { icon: 'add', path: '', text: 'Create label' },
          ]
        },
        {
          icon: 'supervisor_account',
          'icon-alt': 'supervisor_account',
          path: '',
          text: 'Petugas',
          model: false,
          children: [
            { icon: 'speaker_notes', path: '/master/informasi', text: 'Daftar Informasi' },
            { icon: 'event', path: '/master/jadwal', text: 'Daftar Jadwal' },
            { icon: 'room', path: '/master/ruangan', text: 'Daftar Ruangan' },
            { icon: 'assignment', path: '/master/mapel', text: 'Daftar Pelajaran' },
            { icon: 'class', path: '/master/kelas', text: 'Daftar Kelas' },
            { icon: 'grade', path: '/master/jurusan', text: 'Daftar Jurusan' },
            { icon: 'face', path: '/master/pengajar', text: 'Daftar Pengajar' },
            { icon: 'featured_play_list', path: '/petugas', text: 'Daftar Petugas' },
            { icon: 'add_box', path: '/petugas/register', text: 'Register Petugas' },            
          ]
        },
        { icon: 'settings', path: '', text: 'Settings' },      
        { icon: 'help', path: '', text: 'Help' },
      ]
    }
  },
  computed: {    
  },
  methods: {
    ...mapActions('logger/snackbar', [
      'info',
      'success',
      'error',
      'change'
    ]),
    itemClickEvent (path) {      
      this.$router.push(path)
    },
    refresh () {
      this.$store.dispatch('refresh')
        .then(() => {
          this.info('Loading . . .')
        })
        .then(() => {
          setTimeout(() => {            
            this.success('Loading Success')
          }, 1000)
        })
        .catch((error) => {          
          this.error('Oops something error . . .')
        })
    }
  }
}
</script>

<style>
/*#app {
  font-family: 'Avenir', Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  margin-top: 60px;
}*/
</style>
